import * as tslib_1 from "tslib";
import fs from 'fs';
import path from 'path';
import tsImportPluginFactory from 'ts-import-plugin';
import { getTransformer } from 'ts-transform-graphql-tag';
export default function (context, next) {
  return tslib_1.__awaiter(this, void 0, void 0, function () {
    var cwd, ENV, typescriptConfigPath, options, tsconfigPath, importPluginOptions, _a, useGQL;

    return tslib_1.__generator(this, function (_b) {
      cwd = context.cwd, ENV = context.ENV;
      typescriptConfigPath = path.join(__dirname, '../tsconfig.json');
      options = require(typescriptConfigPath);
      tsconfigPath = path.resolve(cwd, 'tsconfig.json');

      if (fs.existsSync(tsconfigPath)) {
        options = require(tsconfigPath);
      }

      options.compilerOptions.sourceMap = ENV.isDevelopment;
      options.compilerOptions.module = 'ESNEXT';
      context.typescriptOptions = context.tsOptions = {
        transpileOnly: true,
        experimentalWatchApi: true,
        compilerOptions: options.compilerOptions
      };
      next();
      importPluginOptions = context.importPluginOptions, _a = context.useGQL, useGQL = _a === void 0 ? true : _a;

      context.tsOptions.getCustomTransformers = function () {
        var before = [];

        if (useGQL) {
          before.push(getTransformer());
        }

        if (importPluginOptions) {
          before.push.apply(before, importPluginOptions.map(function (o) {
            return tsImportPluginFactory(o);
          }));
        }

        return {
          before: before
        };
      };

      return [2];
    });
  });
}